// Sharks.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Sharks.h"
#include "SharksDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HANDLE conH=NULL;

//vypise do debug okna string s danou farbou
DWORD cPrint(const CString& msg,WORD wAttributes)
{
	DWORD retval=0;
	SetConsoleTextAttribute(conH,wAttributes);
	WriteConsole(conH,(LPCTSTR)msg,msg.GetLength(),&retval,NULL);
	return retval;
}

/////////////////////////////////////////////////////////////////////////////
// CSharksApp

BEGIN_MESSAGE_MAP(CSharksApp, CWinApp)
	//{{AFX_MSG_MAP(CSharksApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSharksApp construction

CSharksApp::CSharksApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSharksApp object

CSharksApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSharksApp initialization

CSharksDlg* pdlg=NULL;

BOOL CSharksApp::InitInstance()
{

	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	if(!AllocConsole())
		return false;
	SetConsoleTitle("debug window");
	conH=GetStdHandle(STD_OUTPUT_HANDLE);
	// Standard initialization

	pdlg=new CSharksDlg;
	m_pMainWnd = pdlg;
	pdlg->Create(IDD_SHARKS_DIALOG);

	if (pdlg->A.isConfigReady())
	{
		CMenu* Menu=pdlg->GetMenu();
		Menu->EnableMenuItem(MNU_CONNECTAGENT,MF_GRAYED|MF_BYCOMMAND);
		Menu->EnableMenuItem(ID_LOG_OTVORITZAZNAM,MF_GRAYED|MF_BYCOMMAND);
		Menu->EnableMenuItem(MNU_RECLOG,MF_GRAYED|MF_BYCOMMAND);
		if(!pdlg->A.m_DebugRecord)
		{
			Menu->EnableMenuItem(MNU_ULOZ_ZAZNAM,MF_GRAYED|MF_BYCOMMAND);
		}

		pdlg->A.INIConnectAgent(pdlg);
	}
	return true;
}

int CSharksApp::ExitInstance() 
{
	delete pdlg;
	FreeConsole();
	return CWinApp::ExitInstance();
}
