// SharksDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sharks.h"

#include "SharksDlg.h"
#include "GotoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CSharksDlg dialog

CSharksDlg::CSharksDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSharksDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSharksDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSharksDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSharksDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSharksDlg, CDialog)
	//{{AFX_MSG_MAP(CSharksDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_COMMAND(MNU_EXIT, OnExit)
	ON_COMMAND(MNU_CONNECTAGENT, OnConnectagent)
	ON_WM_KEYDOWN()
	ON_COMMAND(MNU_NARROW, OnNarrow)
	ON_COMMAND(MNU_NORMAL, OnNormal)
	ON_COMMAND(MNU_WIDE, OnWide)
	ON_WM_TIMER()
	ON_COMMAND(ID_UHOL_HRACIEPOLE, OnMNU_Hraciepole)
	ON_COMMAND(ID_LOG_OTVORITZAZNAM, OnLogOtvoritzaznam)
	ON_COMMAND(MNU_RECLOG, OnReclog)
	ON_COMMAND(MNU_ULOZ_ZAZNAM, OnUlozZaznam)
	ON_COMMAND(MNU_GOTO_CYCLE, OnGotoCycle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSharksDlg message handlers

BOOL CSharksDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	A.m_output=this;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSharksDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	CRect rect;
	GetClientRect(&rect);

	if (IsIconic())
	{

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);

		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		A.drawMemory(dc,rect);
	}
}

HCURSOR CSharksDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSharksDlg::OnCancel() 
{
}

void CSharksDlg::OnOK() 
{
//stlacenie ENTER
	A.SayMyPos();
}

void CSharksDlg::OnClose() 
{
	if(A.sync_TimerNumber)
	{
		KillTimer(A.sync_TimerNumber);
		A.sync_TimerNumber=0;
	}
	A.m_output=NULL;
	DestroyWindow();
}

void CSharksDlg::OnExit() 
{
	PostMessage(WM_CLOSE);	
}

void CSharksDlg::OnConnectagent() 
{
	BOOL uspech=A.ConnectAgent();
	if(uspech)
	{
		CMenu* Menu=GetMenu();
		Menu->EnableMenuItem(MNU_CONNECTAGENT,MF_GRAYED|MF_BYCOMMAND);
		Menu->EnableMenuItem(ID_LOG_OTVORITZAZNAM,MF_GRAYED|MF_BYCOMMAND);
		Menu->EnableMenuItem(MNU_RECLOG,MF_GRAYED|MF_BYCOMMAND);
		if(!A.m_DebugRecord)
		{
			Menu->EnableMenuItem(MNU_ULOZ_ZAZNAM,MF_GRAYED|MF_BYCOMMAND);
		}

		A.CreateTimer(this);
	}
}

void CSharksDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default

	//pouzite pismena:
	// I,J,K,L,SPACE,Q,0,1,8,9,A,S
	switch(nChar)
	{
	case 'I':
		A.Dash(100);
		break;
	case 'J':
		A.Turn(-10);
		break;
	case 'L':
		A.Turn(10);
		break;
	case ' ':
		A.Kick(100,0);
		break;
	case 'Q':
		A.KickToGoal();
		break;
	case '0':
		A.Spravanie=None;
		break;
	case '1':
		A.Spravanie=Attacker;
		break;
	case '8':
		A.Spravanie=GoalPerson;
		break;
	case '9':
		A.Spravanie=Tutmak;
		break;
	case 'A':
		{
		for(int i=0;i<10;i++)
			A.ReceiveLogEvent();
		}
		break;
	case 'S':
		A.ReceiveLogEvent();
		break;

	}
	Sleep(100);
	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CSharksDlg::OnNarrow() 
{
	A.Change_View(narrow);
}

void CSharksDlg::OnNormal() 
{
	A.Change_View(normal);	
}

void CSharksDlg::OnWide() 
{
	A.Change_View(wide);
}

void CSharksDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent==A.sync_TimerNumber)
	{//kazdych simulator_step
		if(!A.OnExternTimer())
		{
			KillTimer(nIDEvent);
			A.sync_TimerNumber=0;

			if(A.m_IsConnected)
			{
				MessageBox("Server is down","A sakra!",MB_ICONEXCLAMATION);
			}
			else
			{
				MessageBox("Neuspesne pripojenie");
			}

			PostMessage(WM_CLOSE);
		}
	}

	CDialog::OnTimer(nIDEvent);
}

void CSharksDlg::OnMNU_Hraciepole() 
{
	CMenu* menu=GetMenu();

	if(A.m_output)
	{
		A.m_output=NULL;
		menu->CheckMenuItem(ID_UHOL_HRACIEPOLE,MF_UNCHECKED|MF_BYCOMMAND);
	}
	else
	{
		A.m_output=this;
		menu->CheckMenuItem(ID_UHOL_HRACIEPOLE,MF_CHECKED|MF_BYCOMMAND);
	}
}

void CSharksDlg::OnLogOtvoritzaznam() 
{
	static LPCSTR Filter="Sharks debugLog Files (*.lgf)|*.lgf|All Files(*.*)|*.*||";

	CFileDialog oDlg(TRUE,NULL,NULL,OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,Filter,this);
	int rval=oDlg.DoModal();
	if(rval==IDOK)
	{
		SetCursor(LoadCursor(NULL, IDC_WAIT));
		BOOL success=A.m_DebugLog.loadLog((LPCTSTR)oDlg.GetPathName());
		SetCursor(NULL);

		if(!success) return;

		A.m_DebugMode=TRUE;
		A.m_IsConnected=TRUE;
		A.m_NazovTimu=A.m_DebugLog.team_name;

		CMenu* menu=GetMenu();
		menu->EnableMenuItem(MNU_CONNECTAGENT,MF_GRAYED|MF_BYCOMMAND);
		menu->EnableMenuItem(ID_LOG_OTVORITZAZNAM,MF_GRAYED|MF_BYCOMMAND);
		menu->EnableMenuItem(MNU_GOTO_CYCLE,MF_ENABLED|MF_BYCOMMAND);

	}
}

void CSharksDlg::OnReclog() 
{
	CMenu* menu=GetMenu();
	if(A.m_DebugRecord)
	{
		menu->CheckMenuItem(MNU_RECLOG,MF_UNCHECKED|MF_BYCOMMAND);
		A.m_DebugRecord=FALSE;
	}
	else
	{
		menu->CheckMenuItem(MNU_RECLOG,MF_CHECKED|MF_BYCOMMAND);
		A.m_DebugRecord=TRUE;
	}
}

void CSharksDlg::OnUlozZaznam() 
{
	static LPCSTR Filter="Sharks debugLog Files (*.lgf)|*.lgf|All Files(*.*)|*.*||";

	CFileDialog sDlg(FALSE,"lgf",NULL,OFN_CREATEPROMPT|OFN_HIDEREADONLY|OFN_NOREADONLYRETURN|OFN_OVERWRITEPROMPT,Filter,this);	
	int rval=sDlg.DoModal();
	if(rval==IDOK)
	{
		A.m_DebugLog.team_name=A.m_NazovTimu;
		A.m_DebugLog.saveLog((LPCTSTR)sDlg.GetPathName());
	}
}

void CSharksDlg::OnGotoCycle() 
{
	CGotoDlg g;
	g.m_newCycle=A.GetSimTime()+1;
	g.m_SimCycle.Format("%d",A.GetSimTime());
	if(g.DoModal() == IDOK)
	{
		SetCursor(LoadCursor(NULL, IDC_WAIT));
		while(A.m_DebugLogIndex <= A.m_DebugLog.LogDB.GetUpperBound() && A.GetSimTime() < g.m_newCycle)
		{
			A.ReceiveLogEvent();
		}
		SetCursor(NULL);
	}
}
