// HighAgent.h: interface for the CHighAgent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HIGHAGENT_H__435B5401_2057_11D5_9F49_444553540001__INCLUDED_)
#define AFX_HIGHAGENT_H__435B5401_2057_11D5_9F49_444553540001__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MedAgent.h"
#include "SharkTypes.h"	// Added by ClassView

class CHighAgent : public CMedAgent  
{
public:
	CHighAgent();
	virtual ~CHighAgent();
	Behaviour Spravanie;
	CRealPoint Pozicie[12];

protected:
	PlayMode mode;
	void JumpToHomePos();
	virtual void Handler_NewCycle();
	virtual void Handler_Login(int Cislo,BOOL lava_strana);
	virtual void Handler_ChangeMode(PlayMode mod,int cas);
	void RunToGoal();
	void Player_Attacker();
	BOOL ExistsNearestPlayerToBall();

private:
	void Player_GoalPerson();
	void Player_Tutmak();
};

#endif // !defined(AFX_HIGHAGENT_H__435B5401_2057_11D5_9F49_444553540001__INCLUDED_)
