// Player.h: interface for the CPlayer class.
//
//////////////////////////////////////////////////////////////////////

#include "RealPoint.h"
#include "SharkTypes.h"

#if !defined(AFX_PLAYER_H__F53EAD11_16E2_11D5_A154_0020188DB7DA__INCLUDED_)
#define AFX_PLAYER_H__F53EAD11_16E2_11D5_A154_0020188DB7DA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define PROBABILITY_STEP 6			// krok na znizovanie urcitosti v pamati
#define PROBABILITY_MAX  100		// maximalna urcitost v pamati

class CPlayer  
{
public:
	
	DWORD Flag;
	CRealPoint MyPosition;				//absolutna pozicia
	double speedX;						//X-zlozka rychlosti
	double speedY;						//Y-zlozka rychlosti
	int UniformNumber;					//cislo dresu

	float probability;					//urcitost

	CPlayer();
	CPlayer(const CPlayer& other);		//copy constructor
	CPlayer& operator=(const CPlayer& other);
	virtual ~CPlayer();

	//znizenie urcitosti o delta
	void lowerProbability(int delta=PROBABILITY_STEP);
	//restart urcitosti
	void resetProbability();

	//nastavenie smeru a rychlosti
	// vstup x,y hraca, ktory sa pozera, uhol ktorym sa pozera
	//       zmena pohladu a vzdialenosti
	void setProps(double refX, double refY, double refSpeedX, double refSpeedY, double DirChng, double DistChng);

};

#endif // !defined(AFX_PLAYER_H__F53EAD11_16E2_11D5_A154_0020188DB7DA__INCLUDED_)
